/*
**
****************************************************************************
**
**
**             쌠 (c) 2007 - Atmel Corporation
**             L
**
** 		: ATMEGA88+ATA6832 
** Pʕ	: Hall_sensors.c
** 		: BLDCd@
**            ΰيmݕω荞݂Ə
**
**  :  		  t: : :
** 1.0   2007N124  F.G.  쐬
**
** LICENSE -
**
** ATMEL - 2007
** SĂ̿ĳ ۸т͔@Ȃۏ؂Ȃu󂻂̂܂܁vŒ񋟂܂B
** Atmel͔@ȂړIɑ΂Ă񋟂̓K𖾌܂Bَ̕
** ؁A̖ړIւ̓KAAyєNQ܂݁A񋟂ĳɊւS
** Ă̕ۏ؂ƏAtmel͂Ŕ۔F܂BAtmelͿĳ ۸ׂ̎g
** ̔@ȂԐړI܂͌ʂƂĐ鑹Q܂@Ȃ鑹Qɑ΂ĂӔC
** ܂B
****************************************************************************
**
*/

/*_____ ݸٰ ____________________________________________________________*/

#include "config.h"
#include "Hall_sensors.h"
#include "ATA6832_defs.h"
#include "SPI_interface.h"

/*_____ ϸ ________________________________________________________________*/

/*_____ ` _______________________________________________________________*/

/*_____ ^錾 ___________________________________________________________*/

/*_____ Sϐ ___________________________________________________________*/

/*! H_bridge_CW_cmd[]\BLDCd@v蓮3̔دސ(])g
 *  ݍ킹܂݂܂B̕\ΰيm͂vZꂽwWɂĎw
 *  ܂[Hall_C Hall_B Hall_A]BATA6832d͋쓮ɂė\Ȃǂ16
 *  ޯĖ߂܂ނƂł܂B
 */
const unsigned int H_bridge_CW_cmd[8] =
{
	0,												// ΰيm\ : ĳ֎~
	HS1       | LS3 | PH1             | SI | OLD,	// 2ߕ
	LS1 | HS2             | PH2       | SI | OLD,	// 4ߕ
	      HS2 | LS3       | PH2       | SI | OLD,	// 3ߕ
	      LS2 | HS3             | PH3 | SI | OLD,	// 6ߕ
	HS1 | LS2       | PH1             | SI | OLD,	// 1ߕ
	LS1       | HS3             | PH3 | SI | OLD,	// 5ߕ
	0,												// ΰيm\ : ĳ֎~
};


/*! H_bridge_CW_cmd[]\BLDCd@v蓮3̔دސ(])
 *  gݍ킹܂݂܂B̕\ΰيm͂vZꂽwWɂĎw
 *  ܂[Hall_C Hall_B Hall_A]BATA6832d͋쓮ɂė\Ȃǂ
 *  16ޯĖ߂܂ނƂł܂B
 */
const unsigned int H_bridge_CCW_cmd[8] =
{
	0,												// ΰيm\ : ĳ֎~
	LS1       | HS3             | PH3 | SI | OLD,	// 2ߕ
	HS1 | LS2       | PH1             | SI | OLD,	// 4ߕ
	      LS2 | HS3             | PH3 | SI | OLD,	// 3ߕ
	      HS2 | LS3       | PH2       | SI | OLD,	// 6ߕ
	LS1 | HS2             | PH2       | SI | OLD,	// 1ߕ
	HS1       | LS3 | PH1             | SI | OLD,	// 5ߕ
	0,												// ΰيm\ : ĳ֎~
};



/*! @brief Hall_sensors_ISR_initΰيm͂łݕω荞݂܂B
 *  - PCINT14`8Օ
 *  - ㏸Ɖ~̗[Ŋ荞݂𐶐邱Ƃł悤ΰAAΰBAΰC
 *    eXPCINT10APCINT11APCINT12ō\ݒ
 */ 
void Hall_sensors_ISR_init(void)
{
	/* PCINT1ݕω荞ݏ */
	// PCINT14`8荞݋
	PCICR |= 1 << PCIE1;
	// PCINT10/11/12荞݋
	PCMSK1 |= (1 << PCINT12) | (1 << PCINT11) | (1 << PCINT10);
}

/*! @brief BLDC_start()͓d@nn߂܂B߂̍ŏ̖߂𑗂܂B
 *  ΰيmlɏ]āA(])\Kpׂدލ\ݒ𔲂o
 *  ܂B:
 *  - (ΰيm킩)(])\̎wWvZ
 *  - (Ӑ}]ɏ])\琮(])ް𒊏o
 *  - SPIʂATA6832֖ߑo
 *  - (߰ݸޖ@ɂĒׂ邱Ƃł)SPIڰт]ꂽɂd@J
 *    nԂԂ܂B
 */
Motor_ctrl_t BLDC_start(unsigned char direction)
{
	signed char index;
	SPI_status_t SPI_status;
	Motor_ctrl_t Motor_status = MOTOR_STATUS_STOPPED;

	// Jnŝ߂̐߂߂邽߂ΰيmlǂݍ
	index = PINC;
	index = (index & HALL_MASK) >> 2;

	if (direction == MOTOR_CW)
	{	// (ΰيmlɏ])d@Jn邽߂ɖ߂ATA6832֑o
		ata6832_cmd.value = H_bridge_CW_cmd[index];
		SPI_status = SPI_transmit_16(ata6832_cmd.value);
		if (SPI_status == SPI_Initiate_tx)			// Jnڰтo邩
			Motor_status = MOTOR_STATUS_START_CW;
	}
	else if (direction == MOTOR_CCW)
	{	// (ΰيmlɏ])d@Jn邽߂ɖ߂ATA6832֑o
		ata6832_cmd.value = H_bridge_CCW_cmd[index];
		SPI_status = SPI_transmit_16(ata6832_cmd.value);
		if (SPI_status == SPI_Initiate_tx)			// Jnڰтo邩
			Motor_status = MOTOR_STATUS_START_CCW;
	}
	return Motor_status;
}


/*! @brief hall_sensor_ABC_ISR()ΰيmݕω荞݂܂B
 *  ̊荞ݻٰ݂BLDCd@̊jłBȉ̂悤ΰيm͊
 *  ݂܂B:
 *  - d@ʒu(ΰيml)ɏ]AATA6832œKpFET\ݒ𒊏o
 *    ߂̎wWvZ܂B
 *  - (])\(3̔دނ̊J/)ް𒊏o
 *  - 𒼂SPI쓮֓]
 */
#if defined(__ICCAVR__)			// IAR߲׎gp
#pragma vector= PCINT1_vect		// ATmega88pݕω荞10޸
__interrupt void hall_sensor_ABC_ISR (void)
#else
ISR(PCINT1_vect)
#endif
{
	signed char index;
	index = PINC;
	index = (index & HALL_MASK) >> 2;

	if GET_SWITCH_CW()
		ata6832_cmd.value = H_bridge_CW_cmd[index];

	else if GET_SWITCH_CCW()
		ata6832_cmd.value = H_bridge_CCW_cmd[index];

	SPI_transmit_16(ata6832_cmd.value);

}
